package org.omg.CosNaming;

import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;

public abstract class BindingTypeHelper
{
    private static String _id;
    private static TypeCode __typeCode;
    
    public BindingTypeHelper() {
    }
    
    public static void insert(Any any, BindingType bindingType) {
        OutputStream create_output_stream = any.create_output_stream();
        any.type(type());
        write(create_output_stream, bindingType);
        any.read_value(create_output_stream.create_input_stream(), type());
    }
    
    public static BindingType extract(Any any) {
        return read(any.create_input_stream());
    }
    
    public static synchronized TypeCode type() {
        if (BindingTypeHelper.__typeCode == null) {
            BindingTypeHelper.__typeCode = ORB.init().create_enum_tc(id(), "BindingType", new String[] { "nobject", "ncontext" });
        }
        return BindingTypeHelper.__typeCode;
    }
    
    public static String id() {
        return BindingTypeHelper._id;
    }
    
    public static BindingType read(InputStream inputStream) {
        return BindingType.from_int(inputStream.read_long());
    }
    
    public static void write(OutputStream outputStream, BindingType bindingType) {
        outputStream.write_long(bindingType.value());
    }
    
    static {
        BindingTypeHelper._id = "IDL:omg.org/CosNaming/BindingType:1.0";
        BindingTypeHelper.__typeCode = null;
    }
}
